unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, AgntSrvr, ComCtrls, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Exit1: TMenuItem;
    View1: TMenuItem;
    ShowCharacter1: TMenuItem;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Edit6: TEdit;
    Label8: TLabel;
    Edit7: TEdit;
    Label9: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label10: TLabel;
    Edit8: TEdit;
    PropertySheet1: TMenuItem;
    OpenDialog1: TOpenDialog;
    HideCharacter1: TMenuItem;
    Button3: TButton;
    AgntSrvr1: TAgntSrvr;
    Options1: TMenuItem;
    SpeakMessage1: TMenuItem;
    ListBox1: TListBox;
    Memo1: TMemo;
    SpeedButton1: TSpeedButton;
    Label11: TLabel;
    SpeedButton2: TSpeedButton;
    PlayAnimation1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ShowCharacter1Click(Sender: TObject);
    procedure HideCharacter1Click(Sender: TObject);
    procedure PropertySheet1Click(Sender: TObject);
    procedure SpeakMessage1Click(Sender: TObject);
    procedure PlayAnimation1Click(Sender: TObject);
  private
    { Private declarations }
    ChLoaded: boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Open1Click(Sender: TObject);
var
  abuf : array[0..256] of Char; // declare a reference to an array of Char
begin
  GetWindowsDirectory(@abuf, SizeOf(abuf));//Win32 API call - type Char required
  if AgntSrvr1.CharacterVisible then //if character visible the hide;
    HideCharacter1Click(Self);
  if ChLoaded then              // then unload if previously loaded
    AgntSrvr1.UnloadCharacter;
  ChLoaded := False;           // set a boolean flag that character unloaded
  OpenDialog1.InitialDir := abuf + '\msagent\chars\';//sets open file dialog box
                                                 //directory to system  location
  if not AgntSrvr1.AgntSrvrConnect then
    AgntSrvr1.AgntSrvrConnect := True;  // start the COM server
  if OpenDialog1.Execute then    //open file dialog box - if file is chosen
  begin                                        //set character filename
    AgntSrvr1.CharacterFileName := OpenDialog1.FileName;//which loads character
  end;                                    //display the following:
  ChLoaded := True;
  Edit1.Text := OpenDialog1.FileName;    //file name
  Edit8.Text := AgntSrvr1.CharacterName; // character name - from designer
  Edit2.Text := AgntSrvr1.CharacterGUID; //global identifier for the character
  Edit3.Text := AgntSrvr1.CharacterVersion; // character version
  Edit4.Text := AgntSrvr1.AgentVersion;           // MSAgent version
  Edit5.Text := IntToStr(AgntSrvr1.OriginalCharacterHeight);// original height
  Edit6.Text := IntToStr(AgntSrvr1.OriginalCharacterWidth);// original width
  Edit7.Text := IntToStr(AgntSrvr1.LanguageID); //current language ID
                                              //get the animation names
  ListBox1.Items := AgntSrvr1.AnimationNameList;//for this character and load
                                              //them into a list box
  ListBox1.Items.Add('Stop');    // add this to have a stop command in listbox
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  AgntSrvr1.AgntSrvrConnect := False;  // disconnect from server first just
  ShowMessage('Disconnecting....');
  Close;                            //to be neat... then close app
end;

procedure TForm1.ShowCharacter1Click(Sender: TObject);
begin
  if AgntSrvr1.AgntSrvrConnect then     // if connected to server
  begin
    AgntSrvr1.CharacterShow;    // show the loaded character
    SpeakMessage1.Enabled := True;
    SpeedButton1.Enabled := True;
    SpeedButton2.Enabled := True;
    PlayAnimation1.Enabled := True;
  end;
end;

procedure TForm1.HideCharacter1Click(Sender: TObject);
begin
  AgntSrvr1.CharacterHide;            // hide the character
  SpeakMessage1.Enabled := False;
  SpeedButton1.Enabled := False;
  SpeedButton2.Enabled := False;
  PlayAnimation1.Enabled := False;
end;

procedure TForm1.PropertySheet1Click(Sender: TObject);
begin
  AgntSrvr1.PropertySheetShow;    //show the property sheet
end;

procedure TForm1.SpeakMessage1Click(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to (Memo1.Lines.Count - 1) do
  begin
   AgntSrvr1.CharacterSpeak(Memo1.Lines[i]);
  end; 
end;

procedure TForm1.PlayAnimation1Click(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to (ListBox1.Items.Count - 1) do
  begin
    if ListBox1.Selected[i] then
      if ListBox1.Items[i] = 'Stop' then   //added in Open1Click above
        AgntSrvr1.CharacterStop           // direct command
      else
        AgntSrvr1.PlayAnimation(ListBox1.Items[i]);// else play valid animation
  end;
end;

end.
 